Module javafx.base
Package javafx.beans.property.adapter

## Class JavaBeanDoubleProperty

- java.lang.Object
- - javafx.beans.binding.NumberExpressionBase
  - - javafx.beans.binding.DoubleExpression
    - - javafx.beans.property.ReadOnlyDoubleProperty
      - - javafx.beans.property.DoubleProperty
        - - javafx.beans.property.adapter.JavaBeanDoubleProperty

- All Implemented Interfaces:
    `NumberExpression`, `Observable`, `JavaBeanProperty<Number>`, `ReadOnlyJavaBeanProperty<Number>`, `Property<Number>`, `ReadOnlyProperty<Number>`, `ObservableDoubleValue`, `ObservableNumberValue`, `ObservableValue<Number>`, `WritableDoubleValue`, `WritableNumberValue`, `WritableValue<Number>`

      public final class JavaBeanDoubleProperty
      extends DoubleProperty
      implements JavaBeanProperty<Number>

  A `JavaBeanDoubleProperty` provides an adapter between a regular Java Bean property of type `double` or `Double` and a JavaFX `DoubleProperty`. It cannot be created directly, but a `JavaBeanDoublePropertyBuilder` has to be used.

  As a minimum, the Java Bean class must implement a getter and a setter for the property. The class, as well as the getter and a setter methods, must be declared public. If the getter of an instance of this class is called, the property of the Java Bean is returned. If the setter is called, the value will be passed to the Java Bean property. If the Java Bean property is bound (i.e. it supports PropertyChangeListeners), this `JavaBeanDoubleProperty` will be aware of changes in the Java Bean. Otherwise it can be notified about changes by calling `fireValueChangedEvent()`. If the Java Bean property is also constrained (i.e. it supports VetoableChangeListeners), this `JavaBeanDoubleProperty` will reject changes, if it is bound to an `ObservableValue<Double>`.

  Deploying an Application as a Module

  If the Java Bean class is in a named module, then it must be reflectively accessible to the `javafx.base` module. A class is reflectively accessible if the module `opens` the containing package to at least the `javafx.base` module.

  For example, if `com.foo.MyBeanClass` is in the `foo.app` module, the `module-info.java` might look like this:

      module foo.app {
          opens com.foo to javafx.base;
      }

  Alternatively, a class is reflectively accessible if the module `exports` the containing package unconditionally.

  Since:
    JavaFX 2.1
  See Also:
    `DoubleProperty`, `JavaBeanDoublePropertyBuilder`

- - ### Method Summary

    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addListener​(InvalidationListener listener)` | Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
    `void` | `addListener​(ChangeListener<? super Number> listener)` | Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
    `void` | `bind​(ObservableValue<? extends Number> observable)` | Create a unidirection binding for this `Property`.
    `void` | `dispose()` | Signals to the JavaFX property that it will not be used anymore and any references can be removed.
    `void` | `fireValueChangedEvent()` | This method can be called to notify the adapter of a change of the Java Bean value, if the Java Bean property is not bound (i.e.
    `double` | `get()` | Get the wrapped value.
    `Object` | `getBean()` | Returns the `Object` that contains this property.
    `String` | `getName()` | Returns the name of this property.
    `boolean` | `isBound()` | Can be used to check, if a `Property` is bound.
    `void` | `removeListener​(InvalidationListener listener)` | Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
    `void` | `removeListener​(ChangeListener<? super Number> listener)` | Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
    `void` | `set​(double value)` | Set the wrapped value.
    `String` | `toString()` | Returns a string representation of this `JavaBeanDoubleProperty` object.
    `void` | `unbind()` | Remove the unidirectional binding for this `Property`.

    - ### Methods inherited from class javafx.beans.property.DoubleProperty

      `asObject, bindBidirectional, doubleProperty, setValue, unbindBidirectional`

    - ### Methods inherited from class javafx.beans.property.ReadOnlyDoubleProperty

      `readOnlyDoubleProperty`

    - ### Methods inherited from class javafx.beans.binding.DoubleExpression

      `add, add, add, add, add, divide, divide, divide, divide, divide, doubleExpression, doubleExpression, doubleValue, floatValue, getValue, intValue, longValue, multiply, multiply, multiply, multiply, multiply, negate, subtract, subtract, subtract, subtract, subtract`

    - ### Methods inherited from class javafx.beans.binding.NumberExpressionBase

      `asString, asString, asString, greaterThan, greaterThan, greaterThan, greaterThan, greaterThan, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, lessThan, lessThan, lessThan, lessThan, lessThan, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, numberExpression`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javafx.beans.value.ObservableValue

      `getValue`

    - ### Methods inherited from interface javafx.beans.property.Property

      `bindBidirectional, unbindBidirectional`

    - ### Methods inherited from interface javafx.beans.value.WritableValue

      `getValue`

- - ### Method Detail

    - #### get

          public double get()

      Get the wrapped value. Unlike `WritableValue.getValue()`, this method returns primitive double. Needs to be identical to `WritableValue.getValue()`.
      Specified by:
        `get` in interface `ObservableDoubleValue`
      Specified by:
        `get` in interface `WritableDoubleValue`
      Returns:
        The current value
      Throws:
        `UndeclaredThrowableException` - if calling the getter of the Java Bean property throws an `IllegalAccessException` or an `InvocationTargetException`.

    - #### set

          public void set​(double value)

      Set the wrapped value. Unlike `WritableDoubleValue.setValue(java.lang.Number)`, this method uses primitive double.
      Specified by:
        `set` in interface `WritableDoubleValue`
      Parameters:
        `value` - The new value
      Throws:
        `UndeclaredThrowableException` - if calling the getter of the Java Bean property throws an `IllegalAccessException` or an `InvocationTargetException`.

    - #### bind

          public void bind​(ObservableValue<? extends Number> observable)

      Create a unidirection binding for this `Property`.

      Note that JavaFX has all the bind calls implemented through weak listeners. This means the bound property can be garbage collected and stopped from being updated.

      Specified by:
        `bind` in interface `Property<Number>`
      Parameters:
        `observable` - The observable this `Property` should be bound to.

    - #### unbind

          public void unbind()

      Remove the unidirectional binding for this `Property`. If the `Property` is not bound, calling this method has no effect.
      Specified by:
        `unbind` in interface `Property<Number>`
      See Also:
        `Property.bind(javafx.beans.value.ObservableValue)`

    - #### isBound

          public boolean isBound()

      Can be used to check, if a `Property` is bound.
      Specified by:
        `isBound` in interface `Property<Number>`
      Returns:
        `true` if the `Property` is bound, `false` otherwise
      See Also:
        `Property.bind(javafx.beans.value.ObservableValue)`

    - #### getBean

          public Object getBean()

      Returns the `Object` that contains this property. If this property is not contained in an `Object`, `null` is returned.
      Specified by:
        `getBean` in interface `ReadOnlyProperty<Number>`
      Returns:
        the containing `Object` or `null`

    - #### getName

          public String getName()

      Returns the name of this property. If the property does not have a name, this method returns an empty `String`.
      Specified by:
        `getName` in interface `ReadOnlyProperty<Number>`
      Returns:
        the name or an empty `String`

    - #### addListener

          public void addListener​(ChangeListener<? super Number> listener)

      Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

      Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

      The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

      Specified by:
        `addListener` in interface `ObservableValue<Number>`
      Parameters:
        `listener` - The listener to register
      See Also:
        `ObservableValue.removeListener(ChangeListener)`

    - #### removeListener

          public void removeListener​(ChangeListener<? super Number> listener)

      Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

      If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

      Specified by:
        `removeListener` in interface `ObservableValue<Number>`
      Parameters:
        `listener` - The listener to remove
      See Also:
        `ObservableValue.addListener(ChangeListener)`

    - #### addListener

          public void addListener​(InvalidationListener listener)

      Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

      Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

      The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

      Specified by:
        `addListener` in interface `Observable`
      Parameters:
        `listener` - The listener to register
      See Also:
        `Observable.removeListener(InvalidationListener)`

    - #### removeListener

          public void removeListener​(InvalidationListener listener)

      Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

      If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

      Specified by:
        `removeListener` in interface `Observable`
      Parameters:
        `listener` - The listener to remove
      See Also:
        `Observable.addListener(InvalidationListener)`

    - #### fireValueChangedEvent

          public void fireValueChangedEvent()

      This method can be called to notify the adapter of a change of the Java Bean value, if the Java Bean property is not bound (i.e. it does not support PropertyChangeListeners).
      Specified by:
        `fireValueChangedEvent` in interface `ReadOnlyJavaBeanProperty<Number>`

    - #### dispose

          public void dispose()

      Signals to the JavaFX property that it will not be used anymore and any references can be removed. A call of this method usually results in the property stopping to observe the Java Bean property by unregistering its listener(s).
      Specified by:
        `dispose` in interface `ReadOnlyJavaBeanProperty<Number>`

    - #### toString

          public String toString()

      Returns a string representation of this `JavaBeanDoubleProperty` object.
      Overrides:
        `toString` in class `DoubleProperty`
      Returns:
        a string representation of this `JavaBeanDoubleProperty` object.